Description

Currently, the code sample creates a database with collation_database=utf8_general_ci.  This potentially creates issues

1

 when

sorting some unicode languages.  A better approach would be to specify the collation.

- CREATE DATABASE redmine CHARACTER SET utf8;

+ CREATE DATABASE redmine CHARACTER SET utf8 COLLATE utf8_unicode_ci;

 [1] http://stackoverflow.com/questions/766809/whats-the-difference-between-utf8-general-ci-and-utf8-unicode-ci

Related issues:

Related to Redmine - Defect #18866: MySQL: disappear after 4-Byte UTF-8 Closed

Related to Redmine - Defect #20143: Mailhandler cannot handle 4-byte characters New

Related to Redmine - Defect #21398: Mysql: 500 server error when submitting 4... Closed

Related to Redmine - Feature #31921: Changes to properly support 4 byte chara... Closed

History

#1 - 2015-05-03 02:01 - Toshi MARUYAMA

- Related to Defect #18866: MySQL: disappear after 4-Byte UTF-8 added

#2 - 2015-05-03 02:04 - Toshi MARUYAMA

- Subject changed from RedmineInstall: Step 2 - implement a best practice for MySQL to RedmineInstall: MySQL: collation_database

#3 - 2015-05-03 02:17 - Toshi MARUYAMA

I don't prefer defining utf8_general_ci or utf8_unicode_ci because many Japanese web site recommends utf8_general_ci because of unacceptable

matching HIRAGANA (ひらがな) and KATAKANA (カタカナ).

MySQL 5.5.3 supports utf8mb4_unicode_ci and utf8mb4_general_ci (#18866).

#4 - 2015-06-22 05:48 - Toshi MARUYAMA

- Related to Defect #10772: 4-byte utf-8 characters added

#5 - 2015-06-22 05:49 - Toshi MARUYAMA

- Related to deleted (Defect #18866: MySQL: disappear after 4-Byte UTF-8)

#6 - 2015-06-22 05:54 - Toshi MARUYAMA

- Related to deleted (Defect #10772: 4-byte utf-8 characters)

#7 - 2015-06-22 05:55 - Toshi MARUYAMA

- Related to Defect #18866: MySQL: disappear after 4-Byte UTF-8 added

#8 - 2015-06-22 05:55 - Toshi MARUYAMA

- Related to Defect #20143: Mailhandler cannot handle 4-byte characters added

#9 - 2015-10-28 19:22 - @ go2null

How about the following change:

FROM 
http://stackoverflow.com/questions/766809/whats-the-difference-between-utf8-general-ci-and-utf8-unicode-ci
http://stackoverflow.com/questions/29916610/1273-unknown-collation-utf8mb4-unicode-ci-cpanel
https://www.redmine.org/issues/18866


MySQL

CREATE DATABASE redmine CHARACTER SET utf8;

CREATE USER 'redmine'@'localhost' IDENTIFIED BY 'my_password';

GRANT ALL PRIVILEGES ON redmine.* TO 'redmine'@'localhost';

 For versions of MySQL prior to 5.0.2 - skip the 'create user' step and instead:

GRANT ALL PRIVILEGES ON redmine.* TO 'redmine'@'localhost' IDENTIFIED BY 'my_password';

 

TO 

MySQL

MySQL v5.5.3 and later

CREATE DATABASE redmine CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;

CREATE USER 'redmine'@'localhost' IDENTIFIED BY 'my_password';

GRANT ALL PRIVILEGES ON redmine.* TO 'redmine'@'localhost';

 MySQL v5.0.2 and later

CREATE DATABASE redmine CHARACTER SET utf8 COLLATE utf8_unicode_ci;

CREATE USER 'redmine'@'localhost' IDENTIFIED BY 'my_password';

GRANT ALL PRIVILEGES ON redmine.* TO 'redmine'@'localhost';

 MySQL v5.0.1 and earlier

CREATE DATABASE redmine CHARACTER SET utf8 COLLATE utf8_unicode_ci;

GRANT ALL PRIVILEGES ON redmine.* TO 'redmine'@'localhost' IDENTIFIED BY 'my_password';

 

OR 

Add the following recommendation:

It is recommended to use CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci for MySQL v5.5.3 and later, and CHARACTER SET utf8

COLLATE utf8_unicode_ci for earlier versions.

#10 - 2015-12-14 11:45 - Toshi MARUYAMA

- Related to Defect #21398: Mysql: 500 server error when submitting 4 bytes utf8 (to be saved in the 'notes' field) added

#11 - 2019-08-17 18:20 - Marius BĂLTEANU

- Status changed from New to Closed

RedmineInstall was updated in the mean time.

#12 - 2019-08-17 18:20 - Marius BĂLTEANU

- Related to Feature #31921: Changes to properly support 4 byte characters (emoji) when database is MySQL added
